#!/bin/sh

# Usage message
usage="usage: $0 <cvs_tag>"

tag=$1
name=eclipse-rse
tar_name=$name-fetched-src-$tag

# Ensure we got the desired CVS tag
if [ "x$tag"x = "xx" ]
then
        echo >&2 "$usage"
        exit 1
fi

# Fetch plugins
for f in \
org.eclipse.dstore.core \
org.eclipse.dstore.extra \
org.eclipse.rse \
org.eclipse.rse.connectorservice.dstore \
org.eclipse.rse.connectorservice.local \
org.eclipse.rse.connectorservice.ssh \
org.eclipse.rse.connectorservice.telnet \
org.eclipse.rse.core \
org.eclipse.rse.dstore.security \
org.eclipse.rse.efs \
org.eclipse.rse.efs.ui \
org.eclipse.rse.files.ui \
org.eclipse.rse.importexport \
org.eclipse.rse.processes.ui \
org.eclipse.rse.sdk \
org.eclipse.rse.services \
org.eclipse.rse.services.dstore \
org.eclipse.rse.services.files.ftp \
org.eclipse.rse.services.local \
org.eclipse.rse.services.ssh \
org.eclipse.rse.services.telnet \
org.eclipse.rse.shells.ui \
org.eclipse.rse.subsystems.files.core \
org.eclipse.rse.subsystems.files.dstore \
org.eclipse.rse.subsystems.files.ftp \
org.eclipse.rse.subsystems.files.local \
org.eclipse.rse.subsystems.files.ssh \
org.eclipse.rse.subsystems.processes.core \
org.eclipse.rse.subsystems.processes.dstore \
org.eclipse.rse.subsystems.processes.local \
org.eclipse.rse.subsystems.processes.shell.linux \
org.eclipse.rse.subsystems.shells.core \
org.eclipse.rse.subsystems.shells.dstore \
org.eclipse.rse.subsystems.shells.local \
org.eclipse.rse.subsystems.shells.ssh \
org.eclipse.rse.subsystems.shells.telnet \
org.eclipse.rse.ui \
org.eclipse.rse.useractions \
; do
cvs -d:pserver:anonymous@dev.eclipse.org:/cvsroot/dsdp \
export -r $tag  org.eclipse.tm.rse/plugins/$f;
done

# Fetch features
for f in \
org.eclipse.rse.core-feature \
org.eclipse.rse.dstore-feature \
org.eclipse.rse-feature \
org.eclipse.rse.ftp-feature \
org.eclipse.rse.local-feature \
org.eclipse.rse.remotecdt-feature \
org.eclipse.rse.sdk-feature \
org.eclipse.rse.ssh-feature \
org.eclipse.rse.telnet-feature \
; do
cvs -d:pserver:anonymous@dev.eclipse.org:/cvsroot/dsdp \
export -r $tag org.eclipse.tm.rse/features/$f;
done

# Fetch doc
for f in \
org.eclipse.dstore.doc.isv \
org.eclipse.rse.doc.isv \
org.eclipse.rse.doc.user \
; do
cvs -d:pserver:anonymous@dev.eclipse.org:/cvsroot/dsdp \
export -r $tag org.eclipse.tm.rse/doc/$f;
done
mv -v org.eclipse.tm.rse/doc/* org.eclipse.tm.rse/plugins 
rm -rfv org.eclipse.tm.rse/doc

# Fetch Require plugins using last tag found in org.eclipse.tm.rse/releng/org.eclipse.rse.build/maps/tmcore.map
for f in \
org.apache.oro \
org.apache.commons.net \
; do
cvs -d:pserver:anonymous@dev.eclipse.org:/cvsroot/tools \
export -r v200706111724 org.eclipse.orbit/$f;
done
mv -v org.eclipse.orbit/* org.eclipse.tm.rse/plugins
rm -frv org.eclipse.orbit 

# Fetch remote cdt debuging plugin
for f in \
org.eclipse.rse.remotecdt \
; do
cvs -d:pserver:anonymous@dev.eclipse.org:/cvsroot/dsdp \
export -r $tag org.eclipse.tm.rse/examples/$f;
done
mv -v org.eclipse.tm.rse/examples/* org.eclipse.tm.rse/plugins
rm -rfv org.eclipse.tm.rse/examples

tar -cjf $tar_name.tar.bz2 org.eclipse.tm.rse

